/*This procedure computes the power of AM's tests. 
  It replicates the second panel in Table 8. 
 Set bysimu=0 to get LM_o test; set bysimu=1 for the LM_e test
  In each case, set pct=0.2 to get the first section and 0.4 for the second */


new;

/*---------------------*/

bysimu=1; 
pct=0.2;
/*---------------------*/

rndseed 12345;

lib user gensys.src;
#include nkmp_mod.src
#include fstats.src
#include nkmp_spec.g
#include nkmp_sim.src
#include likseq;

dlibrary -a PszTgSen; 
outwidth 256;
format /mat /on /mb1 /ros 16,8;
_svdtol=1e-10;

msel=zeros(2,1);
msel[1]=1; 
msel[2]=3; 

steady=1;

tau        = 2;
kap        = 0.15;

psi1       = 1.5;
psi2       = 1.00;

rhoR       = 0.60;
rhog       = 0.95;
rhoz       = 0.65;

rr_steady  = 0.40;
pi_steady  = 4.00;
gam_steady = 0.50;

sigR       = 0.2;
sigg       = 0.8;
sigz       = 0.45;



spara=zeros(13,1);
spara[1]=tau;
spara[2]=kap;
spara[3]=psi1;
spara[4]=psi2;
spara[5]=rhoR;
spara[6]=rhog;
spara[7]=rhoz;
spara[8]=rr_steady;
spara[9]=pi_steady;
spara[10]=gam_steady;
spara[11]=sigR;
spara[12]=sigg;
spara[13]=sigz;

Tsimburn=1000;
Tsimtotal=2000;

nn={80,160,240,320};
nsimu=5000;

jk=1;
do while jk<=1;

@first compute finite sample critical values@
f=zeros(nsimu,1);
f90=0;
f95=0;

if bysimu==1;
svar0=simvar(spara,Tsimburn,Tsimtotal,nn[jk],msel);
endif;

pdraw=1;
do while pdraw<=nsimu;

dpara=spara;

@generating simulated series using AS's code@
yt = dsgesim(spara,msel,Tsimburn,Tsimtotal); 
yt=yt[Tsimburn+1:Tsimtotal,.];
yt=yt[1:nn[jk],.];
n=rows(yt);     @sample size@
startf=round(n/32); @the frequency band@
endf=round(n/6);

dimy=cols(yt);  @number of variables@

{H,b_H,Dfmat,fmat,sp_mat0,retcode}=HDmat(dpara,n,msel,startf,endf,steady);
if retcode==0;
yy=yt; 
{loglh,temp1,temp2,temp3}=evalmod(dpara,YY,msel);
nloglh=zeros(rows(loglh),13);
j=1;
do while j<=13; /*compute the score*/
ndpara=dpara;
ndpara[j]=dpara[j]+dpara[j]*1e-6;
{temp0,temp1,temp2,temp3}=evalmod(ndpara,YY,msel);
nloglh[.,j]=(temp0-loglh)/(dpara[j]*1e-6);
j=j+1;
endo;

@ compute the test statistic @
score=sumc(nloglh)/sqrt(rows(nloglh));

if bysimu==0; @compute the sample variance@
svar=(nloglh'nloglh)/rows(nloglh);
else; @compute the population variance@
svar=svar0;
endif;


{va,ve}=eigrs2(svar);

va[1]=abs(va[1])*0; @set the smallest eigenvalue to zero@
svar=ve*diagrv(eye(rows(ve)),va)*ve';

if minc(va)<0;
print "strange error";
print va;
endif;

if abs(rank(svar)-12)>0.5;
print "weird error ";
endif;

f[pdraw]=score'pinv(svar)*score;

pdraw=pdraw+1;
else;
print "error: parameter out of bounds";
endif;
endo;

f=sortc(real(f),1);
f90=f[rows(f)*0.9];
f95=f[rows(f)*0.95];


print "---sample size----" n;
print "critical values" f90 f95 ;


@now do size adjusted power@
rejf=0;  
rejf2=0; 

simu=1;


pdraw=1;
simu=pdraw;

do while pdraw<=nsimu;

drawing:
ru=ceil(rndu(1,1)*13);


rchg=zeros(13,1);
rchg[ru]=spara[ru];
pertb=(rndu(1,1)<=0.5)*2-1;

dpara=spara-pct*pertb*rchg;

{H,b_H,Dfmat,fmat,sp_mat0,retcode}=HDmat(dpara,n,msel,startf,endf,steady);
if retcode==0;


@generating simulated series using AS's code@
yt = dsgesim(dpara,msel,Tsimburn,Tsimtotal); 
yt=yt[Tsimburn+1:Tsimtotal,.];
yt=yt[1:nn[jk],.];
n=rows(yt);     @sample size@

startf=round(n/32); @the frequency band, not needed here@
endf=round(n/6);

dimy=cols(yt);  @number of variables@

{H,b_H,Dfmat,fmat,sp_mat0,retcode}=HDmat(spara,n,msel,startf,endf,steady);
     
yy=yt; 
{loglh,temp1,temp2,temp3}=evalmod(spara,YY,msel);
nloglh=zeros(rows(loglh),13);
j=1;
do while j<=13; 
ndpara=spara;
ndpara[j]=spara[j]+spara[j]*1e-6;
{temp0,temp1,temp2,temp3}=evalmod(ndpara,YY,msel);
nloglh[.,j]=(temp0-loglh)/(spara[j]*1e-6);
j=j+1;
endo;

score=sumc(nloglh)/sqrt(rows(nloglh));

if bysimu==0; @compute the sample variance@
svar=(nloglh'nloglh)/rows(nloglh);
else; @compute the population variance@
svar=svar0;
endif;

{va,ve}=eigrs2(svar);

va[1]=abs(va[1])*0; @set the smallest eigenvalue to zero@
svar=ve*diagrv(eye(rows(ve)),va)*ve';

if minc(va)<0;
print "strange error";
print va;
endif;

if abs(rank(svar)-12)>0.5;
print "weird error";
endif;

am=score'pinv(svar)*score;

        if real(am)>=f95;
        rejf=rejf+1;
        endif;

        if real(am)>=f90;
        rejf2=rejf2+1;
        endif;

pdraw=pdraw+1;

else;
goto drawing;

endif;
endo;

print pdraw-1 steady "5% test" rejf/(pdraw-1) "10% test" rejf2/(pdraw-1); 

jk=jk+1;
endo;



proc(1)=simvar(spara,Tsimburn,Tsimtotal,bigT,msel);
local yt,n,nrep,nloglh, simu,loglh,temp1,temp2,temp3,svar,score,ndpara,temp0;
simu=1;
nrep=5000;
score=zeros(13,nrep);
do while simu<=nrep;
    yt = dsgesim(spara,msel,Tsimburn,Tsimtotal); 
    yt=yt[Tsimburn+1:Tsimtotal,.];
    yt=yt[1:bigT,.];
    n=rows(yt);     @sample size@
    {loglh,temp1,temp2,temp3}=evalmod(spara,yt,msel);
    nloglh=zeros(rows(loglh),13);
    j=1;
    do while j<=13; 
        ndpara=spara;
        ndpara[j]=spara[j]+spara[j]*1e-6;
        {temp0,temp1,temp2,temp3}=evalmod(ndpara,yt,msel);
        nloglh[.,j]=(temp0-loglh)/(spara[j]*1e-6);
        j=j+1;
    endo;

score[.,simu]=sumc(nloglh)/sqrt(rows(nloglh));
simu=simu+1;
endo;
svar=score*score'/nrep;
retp(svar);
endp;


